﻿using AutoMapper;
using AutoMapper.Configuration.Conventions;
using CarShop.Logic;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace CarShop.Web.Models
{
    // legacy: Mapper.Initialize at AppDomain startup
    // core: services.AddAutoMapper(assembly[])
    public class MapperFactory
    {
        public static IMapper CreateMapper()
        {
            var config = new MapperConfiguration(cfg =>
            {
                cfg.CreateMap<CarShop.Data.Car, CarShop.Web.Models.Car>().
                    ForMember(dest => dest.Id, map => map.MapFrom(src => src.Id)).
                    ForMember(dest => dest.Name, map => map.MapFrom(src => src.Model)).
                    ForMember(dest => dest.Price, map => map.MapFrom(src => src.BasePrice)).
                    ForMember(dest => dest.BrandName, map => map.MapFrom(src => src.Brand == null ? "" : src.Brand.Name));
                    // ReverseMap().
                    // ForMember(dest => dest.brands, map => map.MapFrom(src => logic.GetBrandByName(src.BrandName)));
            });
            return config.CreateMapper();
        }
    }
}